#include<bits/stdc++.h>
using namespace std;
int ucln(int a, int b)
{
    if(b==0) return a;
    else return ucln(b, a%b);
}
int main()
{
    ifstream fi("dquc.inp");
    ofstream fo("dquc.out");
    int n;
    fi>>n;
    int a[n];
    for(int i=0; i<n; i++)
    {
        fi>>a[i];
    }
    int r;
    if(n==1) r=a[0];
    else if(n==2) r=ucln(a[0],a[1]);
    else if(n>2)
    {
        for(int i=0; i<n-2; i++)
        {
            r=ucln(ucln(a[i], a[i+1]),a[i+2]);
        }
    }
    fo<<r;
}
